stages:
  - build

.build_docker_image: &build_docker_image
  image: docker:stable
  services:
    - docker:20.10.9-dind
  stage: build
  before_script:
    - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN registry.gitlab.com
  script:
    - docker build -t registry.gitlab.com/jordane.pelloux/statir/$CONTAINER:$CI_COMMIT_REF_SLUG -f ${BASE_DIR:-$CONTAINER}/$DOCKERFILE ${BASE_DIR:-$CONTAINER}
    - docker tag registry.gitlab.com/jordane.pelloux/statir/$CONTAINER:$CI_COMMIT_REF_SLUG registry.gitlab.com/jordane.pelloux/statir/$CONTAINER:latest
    - docker push registry.gitlab.com/jordane.pelloux/statir/$CONTAINER:latest
    - docker push registry.gitlab.com/jordane.pelloux/statir/$CONTAINER:$CI_COMMIT_REF_SLUG

build:backend:
  <<: *build_docker_image
  only:
    refs:
      - master
    changes:
      - .gitlab-ci.yml
      - backend/**/*
  variables:
    CONTAINER: backend
    DOCKERFILE: Dockerfile.prod

build:front:
  <<: *build_docker_image
  only:
    refs:
      - master
    changes:
      - .gitlab-ci.yml
      - front/**/*
  variables:
    CONTAINER: front
    DOCKERFILE: Dockerfile.prod
